def is_empty[A](l: list[A]) -> bool:
    match l:
        case []:
            return True
        case _:
            return False


"""
def hd[A](l: list[A]) -> A | None:
    match l:
        case [h, *_]:
            return h
        case _:
            return None
"""

""" 
def hd[A](l: list[A]) -> A:
    match l:
        case [h, *t]:
            return h
        case _:
            raise ValueError
 """

""" 
def tl[A](l: list[A]) -> list[A] | None:
    match l:
        case [h, *t]:
            return t
        case _:
            return None
 """


def factorial(n: int) -> int:
    if n == 0:
        return 1
    else:
        return n * factorial(n - 1)


def hd[A](l: list[A]) -> A:
    [h, *_] = l
    return h


def tl[A](l: list[A]) -> list[A]:
    [_, *t] = l
    return t


""" 
def length[A](l: list[A]) -> int:
    if l != []:
        return 1 + length(tl(l))
    else:
        return 0
"""


def length[A](l: list[A]) -> int:
    match l:
        case [_, *t]:
            return 1 + length(t)
        case _:
            return 0


""" 
def rev[A](l: list[A]) -> list[A]:
    match l:
        case [h, *t]:
            rev_t = rev(t)
            # print(rev_t)
            return rev_t + [h]
        case _:
            return []
 """


def rev_o_rev[A](l: list[A]) -> list[A]:
    return rev(rev(l))


def concat[A](l: list[list[A]]) -> list[A]:
    match l:
        case [h, *t]:
            concat_t = concat(t)
            return h + concat_t
            # return [*h, *concat_t]  (alternative)
        case _:
            return []


""" 
def rev_append[A](l1: list[A], l2: list[A]) -> list[A]:
    return rev(l1) + l2
 """


def rev_append[A](l1: list[A], l2: list[A]) -> list[A]:
    match l1:
        case [h, *t]:
            return rev_append(t, [h] + l2)
        case _:
            return l2


def rev[A](l: list[A]) -> list[A]:
    return rev_append(l, [])

# rev_append([1,2,3], [4,5,7])
# rev_append([h,*t], [4,5,7])
# h = 1
# t = [2,3]
# rev_append(t, [h] + l2) = [3,2,1,4,5,7]


def nth[A](l: list[A], i: int) -> A:
    match l:
        case [h, *t]:
            if i == 0:
                return h
            else:
                return nth(t, i - 1)
        case _:
            raise IndexError


def take[A](l: list[A], i: int) -> list[A]:
    if i == 0:
        return []
    else:
        match l:
            case [h, *t]:
                return [h] + take(t, i - 1)
            case _:
                raise IndexError


""" 
def zip[A, B](l1: list[A], l2: list[B]) -> list[tuple[A,B]]:
    match (l1, l2):
        case ([h1, *t1], [h2, *t2]):
            return [(h1, h2), *zip(t1, t2)]
        case (_, _):
            return []
 """


# Version with failure
def zip[A, B](l1: list[A], l2: list[B]) -> list[tuple[A, B]]:
    match (l1, l2):
        case ([h1, *t1], [h2, *t2]):
            return [(h1, h2), *zip(t1, t2)]
        case ([_, *_], _):
            raise ValueError
        case (_, [_, *_]):
            raise ValueError
        case (_, _):
            return []


""" 
def last[A](l: list[A]) -> A:
    return hd(rev(l))
 """

""" 
def last[A](l: list[A]) -> A:
    return nth(l, length(l) - 1)
 """

""" 
def last[A](l: list[A]) -> A:
    match l:
        case [h, *t]:
            if t == []:
                return h
            else:
                return last(t)
        case _:
            raise ValueError
 """


def last[A](l: list[A]) -> A:
    match l:
        case [h]:
            return h
        case [h, *t]:
            return last(t)
        case _:
            raise ValueError


def drop[A](l: list[A], i: int) -> list[A]:
    if i == 0:
        return l
    else:
        match l:
            case [_, *t]:
                return drop(t, i - 1)
            case _:
                raise IndexError


def unzip[A, B](l: list[tuple[A, B]]) -> tuple[list[A], list[B]]:
    match l:
        case [(h1, h2), *t]:
            (t1, t2) = unzip(t)
            return ([h1, *t1], [h2, *t2])
        case _:
            return ([], [])


def zip_o_unzip[A, B](l: list[tuple[A, B]]) -> list[tuple[A, B]]:
    (l1, l2) = unzip(l)
    return zip(l1, l2)


def unzip_o_zip[A, B](l: tuple[list[A], list[B]]) -> tuple[list[A], list[B]]:
    (l1, l2) = l
    return unzip(zip(l1, l2))
